// $Id:
// #####################################################################
//
//    ocsStartupLima.hh
//
//    Startup the ocs system for the user Ivan Lima
//    Optical Communication Systems Simulator
//
//    Copyright:
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
// #####################################################################

//  ## Adapted from Zweck's startup

#ifndef _MY_STARTUP_HH_
#define _MY_STARTUP_HH_

#include "ocsProcessControl.hh"

#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string>
  using namespace std;


#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsConst.hh"
#include "ocsReducedModelTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsRanNumGen.hh"


//! This class reads in parameters for your particular application


/*!

This class could be made more user frienly, but I have not changed
it because I want you to be able to test the code by rerunning 
the jobs Ivan already ran when he validated the code.

*/

class MyStartup
{
   public:
      MyStartup(string InFileName, int argc, char *argv[]);
      int GetSimType(void) {return SimType;};
      int GetQtStatSamples(void) {return qtStatSamples;};
      int GetQtMapSpans(void) {return qtMapSpans;};
      int GetIntParam(int ii) {return IntParam[ii];};
      double GetDoubleParam(int ii) {return DoubleParam[ii];};
   private:
      ProcessControl oProcessControl;
      int ProcessControlMode;
      int SimType;
      int qtStatSamples;
      int qtMapSpans;
      int IntParam[11];
      double DoubleParam[11];
      string LogFileName;
};

#endif // _MY_STARTUP_HH_
