// $Id: StartupExample.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $

//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################


#ifndef _STARTUP_EXAMPLE_HH_
#define _STARTUP_EXAMPLE_HH_


#include "ocsProcessControl.hh"

#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string>
  using namespace std;


#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsConst.hh"
#include "ocsTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsRanNumGen.hh"

class StartupExample
{

public:

  StartupExample(string InFileName, int argc, char *argv[]);

  string GetJobDir() { return JobDir;};
  string GetJobName() {return JobName;};
  string GetJobPrefix() {return JobPrefix;};
  string GetInputFilesDir() {return InputFilesDir;};
  
  int GetSimType() {return SimType;};
  int GetQtStatSamples() {return qtStatSamples;};
  int GetQtMapSpans() {return qtMapSpans;};
  
  int GetNumChannsDemux() {return NumChannsDemux;};
  int GetDemuxChannsArray(int ArrayIndex) 
                          {return  DemuxChannsArray[ArrayIndex];};



private:
  ProcessControl oProcessControl;
  int ProcessControlMode;
  string JobDir;
  string JobName;
  string JobPrefix;
  string InputFilesDir;
  string LogFileName;

  int SimType;
  int qtStatSamples;
  int qtMapSpans;

  int NumChannsDemux;
  int * DemuxChannsArray;



};

#endif /* _STARTUP_EXAMPLE_HH_ */
