// $Id: StartupLinearn.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $ 

//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _STARTUP_RON_NOISE_HH_
#define _STARTUP_RON_NOISE_HH_

#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string>
  using namespace std;


#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsConst.hh"
#include "ocsTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsRanNumGen.hh"

class StartupZweck
{

public:

StartupZweck(string InFileName);

  string GetJobDir() { return JobDir;};
  string GetJobName() {return JobName;};
  string GetJobPrefix() {return JobPrefix;};
  string GetInputFilesDir() {return InputFilesDir;};
  
  int GetSimType() {return SimType;};
  int GetQtStatSamples() {return qtStatSamples;};
  int GetQtMapSpans() {return qtMapSpans;};
  int GetBeta3ZeroFlag() {return Beta3ZeroFlag;};
  int GetNonLinearityZeroFlag() {return NonLinearityZeroFlag;};
  int GetFiberLossZeroFlag() {return FiberLossZeroFlag;};
  int GetTypeAmp() {return TypeAmp;}; 
  int GetAmpsNoiseOffFlag() {return AmpsNoiseOffFlag;}; 

  bool GetWriteComplexFieldsFlag() {return WriteComplexFieldsFlag;};
  

  double GetRelativeErrorGoal() {return RelativeErrorGoal;};

  int GetOutputStepSizesFlag() {return OutputStepSizesFlag;};

  int GetDebugLevelAmps() {return DebugLevelAmps;};

  int GetTypeStepSizes() { return TypeStepSizes;};

  double GetWalkOffParameter() { return WalkOffParameter;};

  int GetJitterSeparationFrequency() {return JitterSeparationFrequency;};

private:

string JobDir;
string JobName;
string JobPrefix;
string InputFilesDir;
string LogFileName;


int SimType;
int qtStatSamples;
int qtMapSpans;

double RelativeErrorGoal;
double WalkOffParameter;

int TypeStepSizes;

  // Flags

int Beta3ZeroFlag;
int NonLinearityZeroFlag;
int FiberLossZeroFlag;	
int TypeAmp;
int AmpsNoiseOffFlag;

int OutputStepSizesFlag;

bool WriteComplexFieldsFlag;

int DebugLevelAmps;

  // Parameters

int JitterSeparationFrequency;

};

#endif /* _STARTUP_RON_NOISE_HH_ */
