
//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _STARTUP_SECH_LASER_HH_
#define _STARTUP_SECH_LASER_HH_

#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string>
  using namespace std;


#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsConst.hh"
#include "ocsTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsRanNumGen.hh"

class StartupSechLaser
{

public:

StartupSechLaser(string InFileName);

  string GetJobDir() { return JobDir;};
  string GetJobName() {return JobName;};
  string GetJobPrefix() {return JobPrefix;};
 
  double GetFstOrDisp() {return FstOrDisp;};
  double GetGamma() {return Gamma;};
  double GetAttenuationLinear() {return AttenuationLinear;};
  double GetUnsaturatedLinearGain() {return UnsaturatedLinearGain;};


private:

string JobDir;
string JobName;
string JobPrefix;
string LogFileName;

double FstOrDisp;
double Gamma;
double AttenuationLinear;
double UnsaturatedLinearGain;


};

#endif
