
//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _STARTUP_SIMILARITON_HH_
#define _STARTUP_SIMILARITON_HH_

#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string>
  using namespace std;


#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsConst.hh"
#include "ocsTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsRanNumGen.hh"

class StartupSimilariton
{

public:

StartupSimilariton(string InFileName);

  string GetJobDir() { return JobDir;};
  string GetJobName() {return JobName;};
  string GetJobPrefix() {return JobPrefix;};
 
  
  int GetSimType() {return SimType;};
  double GetTotalFiberLength() {return TotalFiberLength;};
  int GetNumLaserRoundTrips() {return NumLaserRoundTrips;};
  int GetFreqOutputStats() { return FreqOutputStats;};
  int GetNumMonteCarloSamples() {return NumMonteCarloSamples;};

  bool GetWriteComplexFieldsFlag() {return WriteComplexFieldsFlag;};
  string GetSignalFileName() {return SignalFileName;};

  bool GetReadSignalData() {return ReadSignalData;};

  double GetDispSwingMin() {return DispSwingMin;};
  double GetDispSwingMax() {return DispSwingMax;};
  double GetDispAvMin() {return DispAvMin;};
  double GetDispAvMax() {return DispAvMax;};
 
  int GetDispSwingN() {return DispSwingN;};
  int GetDispAvN() {return DispAvN;};



private:

string JobDir;
string JobName;
string JobPrefix;
string LogFileName;


int SimType;
double TotalFiberLength;
int NumLaserRoundTrips;
int FreqOutputStats;
int NumMonteCarloSamples;
bool WriteComplexFieldsFlag;
string SignalFileName;
bool ReadSignalData;

double DispSwingMin;
double DispSwingMax;
double DispAvMin;
double DispAvMax;

int DispSwingN;
int DispAvN;


};

#endif /* _STARTUP_SIMILARITON_HH_ */
