// $Id: StartupTyco.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $ 

//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _STARTUP_TYCO_HH_
#define _STARTUP_TYCO_HH_

#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string>
  using namespace std;


#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsConst.hh"
#include "ocsTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsRanNumGen.hh"

class StartupZweck
{

public:

StartupZweck(string InFileName);

  string GetJobDir() { return JobDir;};
  string GetJobName() {return JobName;};
  string GetJobPrefix() {return JobPrefix;};
  string GetInputFilesDir() {return InputFilesDir;};
  
  int GetSimType() {return SimType;};
  int GetQtStatSamples() {return qtStatSamples;};
  int GetQtMapSpans() {return qtMapSpans;};
  int GetWriteDTPFlag() {return WriteDTPFlag;};
  int GetWriteWithinMapFlag() {return WriteWithinMapFlag;};
  int GetBeta3ZeroFlag() {return Beta3ZeroFlag;};
  int GetNonLinearityZeroFlag() {return NonLinearityZeroFlag;};
  int GetFiberLossZeroFlag() {return FiberLossZeroFlag;};
  int GetTypeAmp() {return TypeAmp;}; 
  int GetAmpsNoiseOffFlag() {return AmpsNoiseOffFlag;}; 
  int GetNumExptsForIvansED() {return NumExptsForIvansED;}; 
  int GetTypeAmplifierNoise(void) {return TypeAmplifierNoise;};

  
  int GetWriteComplexFieldsFlag() {return WriteComplexFieldsFlag;};
  int GetWriteAveragePowerdBmFlag() {return WriteAveragePowerdBmFlag;};
  int GetWritePulseWidthFlag() {return WritePulseWidthFlag;};

  double GetRelativeErrorGoal() {return RelativeErrorGoal;};

  int GetOutputStepSizesFlag() {return OutputStepSizesFlag;};

  int GetWriteSNRandOSAFlag() { return WriteSNRandOSAFlag;};


  int GetFreqOutputSNR() {return FreqOutputSNR;};
  int GetFreqOutputReceiverStats() {return FreqOutputReceiverStats;};

  int GetOutputAverageChirpFlag() {return OutputAverageChirpFlag;};

  int GetRandomizeBitStringsForMC() {return RandomizeBitStringsForMC;};

  int GetDebugLevelAmps() {return DebugLevelAmps;};

  int GetWriteAccDispFlag() {return WriteAccDispFlag;};

  int GetKeepDCFlag() {return KeepDCFlag;};

  int GetDemuxChannelIndex() {return DemuxChannelIndex;};  

  bool GetHybridSignalFlag() {return HybridSignalFlag;};


private:

string JobDir;
string JobName;
string JobPrefix;
string InputFilesDir;
string LogFileName;


int SimType;
int qtStatSamples;
int qtMapSpans;

int NumExptsForIvansED;

double RelativeErrorGoal;


  // Flags

int WriteSNRandOSAFlag;
int WriteAveragePowerdBmFlag;
int WriteComplexFieldsFlag;
int WriteDTPFlag;
int WriteWithinMapFlag;
int Beta3ZeroFlag;
int NonLinearityZeroFlag;
int FiberLossZeroFlag;	
int TypeAmp;
int AmpsNoiseOffFlag;
  int TypeAmplifierNoise;
int OutputStepSizesFlag;

int RandomizeBitStringsForMC;

int FreqOutputSNR;
int FreqOutputReceiverStats;

int OutputAverageChirpFlag;

int DebugLevelAmps;

int  WriteAccDispFlag;
int WritePulseWidthFlag;

  int  KeepDCFlag;
  int DemuxChannelIndex;

  bool HybridSignalFlag;

  // Parameters




};

#endif /* _STARTUP_TYCO_HH_ */
