// $Id: StartupZweck.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $

//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################


#ifndef _STARTUP_ZWECK_HH_
#define _STARTUP_ZWECK_HH_

#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string>
  using namespace std;


#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsConst.hh"
#include "ocsTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsRanNumGen.hh"

class StartupZweck
{

public:

StartupZweck(string InFileName);

  string GetJobDir() { return JobDir;};
  string GetJobName() {return JobName;};
  string GetJobPrefix() {return JobPrefix;};
  string GetInputFilesDir() {return InputFilesDir;};
  
  int GetSimType() {return SimType;};
  int GetQtStatSamples() {return qtStatSamples;};
  int GetQtMapSpans() {return qtMapSpans;};
  int GetWriteDTPWithinMap() {return WriteDTPWithinMap;};
  double GetWigglePeriod() {return WigglePeriod;};
  int GetGhostPulseBit() {return GhostPulseBit;};
  int Getii_z() {return ii_z;};
  int GetFiberLossZeroFlag() {return FiberLossZeroFlag;};

  double GetDispMin() {return DispMin;};
  double GetDispDelta() {return DispDelta;};
  int GetNumDispPts() {return NumDispPts;};

  double GetLeftTime() {return LeftTime;};
  double GetRightTime() {return RightTime;};

  double GetLeftTimeZero() {return LeftTimeZero;};
  double GetRightTimeZero() {return RightTimeZero;};
  double GetLeftTimeOne() {return LeftTimeOne;};
  double GetRightTimeOne() {return RightTimeOne;};
  int GetFreqOutputStats() {return FreqOutputStats;};
  int GetFreqOutputMC() {return FreqOutputMC;};
  int GetWiggleFlag() {return WiggleFlag;};

  double GetWiggleShift() {return WiggleShift;};
  int GetKeepDCFlag() {return KeepDCFlag;};
  int SetSndOrDispZeroFlag() {return SndOrDispZeroFlag;}
  int GetWriteDTP() {return WriteDTP;};

  double GetRelativeErrorGoal() {return RelativeErrorGoal;};

  int GetWritePulseWidthFlag() {return WritePulseWidthFlag;};
  int GetWriteAveragePowerdBmFlag() {return WriteAveragePowerdBmFlag;};
  int GetOutputStepSizesFlag() {return OutputStepSizesFlag;};
  int GetNumOnes() {return NumOnes;};

private:

string JobDir;
string JobName;
string JobPrefix;
string InputFilesDir;
string LogFileName;


int SimType;
int qtStatSamples;
int qtMapSpans;
int FiberLossZeroFlag;
int WriteDTPWithinMap;

double WigglePeriod;
double WiggleShift;

int KeepDCFlag;
int SndOrDispZeroFlag;

double RelativeErrorGoal;

int GhostPulseBit;
int ii_z;


  int WiggleFlag;

  double DispMin;
  double DispDelta;
  int NumDispPts;

  double LeftTime,RightTime;

  double LeftTimeZero,RightTimeZero;
  double LeftTimeOne,RightTimeOne;

  int FreqOutputStats;
  int FreqOutputMC;
  int WriteDTP;
  int WriteAveragePowerdBmFlag;
  int WritePulseWidthFlag;
  int OutputStepSizesFlag;
  int NumOnes;

};

#endif /* _STARTUP_ZWECK_HH_ */



