// $Id: ocs.hh,v 1.2 2006/05/11 23:58:19 zweck Exp $


// #####################################################################
//
//    ocs.hh
//
//    Header file for the modules of ocs system 
//    Optical Communication Systems Simulator
//
//    Copyright:
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
// #####################################################################


#include "ocsTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsBitString.hh"
#include "ocsElecFilter.hh"
#include "ocsElecSignalStat.hh"
#include "ocsHistogram.hh"

#include "ocsOptAmplifier.hh"
#include "ocsOptFiber.hh"
#include "ocsOptFilter.hh"
#include "ocsOptSignal.hh"
#include "ocsPhotodetector.hh"

#include "ocsBeamSplitter.hh"
#include "ocsPolarizer.hh"
#include "ocsPolarizBeamSplitter.hh"
#include "ocsPolarizTransformer.hh"
#include "ocsPolDepAttenuator.hh"
#include "ocsOptDemuxer.hh"
#include "ocsElecEqualizer.hh" 

#include "ocsRanNumGen.hh"
#include "ocsHistogram2D.hh"
#include "ocsReceiverSubsystem.hh"
#include "ocsOptFiberLocalError.hh"
#include "ocsLumpedLoss.hh"
#include "ocsOptSpectrumAnalyzer.hh"

#include "StatisticsOfArray.hh"

#include "ocsReceiverSemiAnalytical.hh"
#include "GaussianReceiver.hh"

#include "MatrixTools.hh"
#include "GeneralRealMatrix.hh"
#include "NoiseCovariance.hh"
#include "ChiSquareReceiver.hh"
#include "SaturableAbsorber.hh"


// ## Reduced Polarization model
#include "ocsReduOptSignal.hh"
#include "ocsReduPolDepAttenuator.hh"
#include "ocsReduOptAmplifier.hh"
#include "ocsReduOptFiber.hh"
#include "ocsReduPolarizTransformer.hh"
#include "ocsReduLumpedLoss.hh"

