//Id: Raman.cc


//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2001):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//##################################################################


// ###############################################
// 
//
// 
// ###############################################

#include <iostream.h>
#include <complex.h>

#include "ocs.hh"
#include "StartupJH.hh"
#include "ocsOptDataWriter.hh"
#include "MachZehnder.hh"
#include "ocsRamanAmp.hh"


extern ofstream *LogFile;

void RamanBasic(StartupJH * MyStartup);

// ####################################################

// ## Application Wrapper

void MyApplication(int argc, char *argv[])  
{

  StartupJH MyStartup("Startup.in");

  switch(MyStartup.GetSimType())
   {
    
     case 1: 
       RamanBasic(&MyStartup);
       break;

    default:
      cerr << "MyApplication: Invalid choice of application in SimType" 

           << endl;
      exit(1);
          
   } // end switch

} // end MyAppn


// ####################################################

void RamanBasic(StartupJH * MyStartup)
{
  double CLOCK_PER_SEC = 1e+6;
  clock_t Start, Finish;
  double Duration;
  char  C_String[40];
  string FileName,FileName1,FileName2;
  Duration=0;

  LogFileSeparator();

  *LogFile <<  endl << "RamanBasic" << endl;
 
  
  string InDir = MyStartup->GetInputFilesDir();
  string Job = MyStartup->GetJobPrefix();
  RanNumGen * RNG;
  RNG = new RanNumGen(InDir + "RanNumGen.in");

  RamanAmp * oRaman;
  oRaman = new RamanAmp(Job, InDir + "Raman.in", RNG, 1);

  oRaman->ReadPlainFileGainLoss(45000, InDir + "Kidorf");
  oRaman->AllocateMemory();




 int Lp=0;	
   	Finish = clock();
 	if(double(Finish - Start)<0){
   		cerr << "time must >0" << endl 
       		<< "Aborting now! " << endl;
		}
	 
	Duration += (double)(Finish - Start) / CLOCK_PER_SEC;
  cout.precision(10);
  cout << endl << "Duration = " << Duration << endl;
  
  sprintf(C_String,"SignalOutdB.dat");
  FileName = Job + C_String;
  oRaman->WriteSignalOutputPowerdB(FileName);

  
  sprintf(C_String,"PumpOutdB.dat");
  FileName = Job + C_String;
  oRaman->WritePumpPowerdB(FileName);
  
 // ########## Initialize OSAs ###########################
	delete oRaman;
	delete RNG;
   cout << "THE END" << endl;
   *LogFile << "THE END" << endl;



} // ## end RamanBasic

// #############################################






