// $Id: ReduMain.cc,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $

// ####################################################################
//
//    main.cc
//    
//    Main module of the OCS Reduced Model 
//    Optical Communication Systems Simulator
//
//    This program is being developed in order to model and to analyze
//    terrestrial fiber optical systems.
//
//    Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
// #####################################################################

#include <iostream.h>
#include <complex.h>
#include "ReduMain.hh"

// ## Declare and initialize the LogFile which every object can write
// ## output to provided that at the top of the classes src file
// ## we have the declaration extern ofstream LogFile; 

// ## NOTE: The LogFile declaration below must be the very first definition
// ## of ocs.cc since LogFile is used by other objects, such as InputData in.
// ## The point is that ofstream LogFile allocates memory for LogFile.
// ## Classes which use LogFile (declared as an external variable) 
// ## assume that memory is already allocated for the ofstream  LogFile
// ## Otherwise we'll core dump.

ofstream *LogFile;

// ##### Initialize the global object with the input data;


// ## Prototypes of the simulations


void MyApplication(int argc, char *argv[]);


//! The main program simply calls MyApplication which is a function
//! in ReduExampleApplications.cc

int main(int argc, char *argv[])
{   

    //## Allow the process to migrate through Mosix
    lock_or_unlock_mosix(MOSIX_UNLOCK);

    // ##### Creates a global Log File to which all objects can write to
   
   nice(20);
   MyApplication(argc, argv);

   LogFileSeparator();
   *LogFile << "Simulation finished normally. " <<endl;

   LogFile->close();

   return 1;
}

//#####################################


