// $Id: StartupExample.cc,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $

//###################################################################
//
//      Optical Communication Systems Simulator Example
//
//      For other examples check the personal applications
//      of the current users, such as ocsApp[LastName].cc
//
//      Copyright (2000):
//      Optical Fiber Communications Laboratory (OFCL)
//      Computer Science & Electrical Engineering Department (CSEE)
//      University of Maryland Baltimore County (UMBC)
//
//###################################################################


# include "StartupExample.hh"

extern ofstream *LogFile;

StartupExample::StartupExample(string InFileName, int argc, char *argv[])
{


ifstream InFile(InFileName.c_str(),ios::in);    
   
if (!InFile) 
 {
    cerr << "Error: Input file "<< InFileName 
         << " could not be opened."<< endl;
    exit(1);
 }

ProcessControlMode = ReadInt("ProcessControlMode"," ",0,-1,LOWER_ONLY,&InFile);

JobDir = ReadString("JobDir",&InFile);
JobName =  ReadString("JobName",&InFile);

LogFileName = JobDir + JobName + ".log";

 cout << endl
      << "Log File = " << LogFileName << endl << endl;

LogFile= new ofstream(LogFileName.c_str(),ios::out);
   
if (!LogFile) 
  {
    cerr << "Error: ocs.log could not be open." << endl << flush;
    exit(1);
  }    

JobPrefix = JobDir + JobName + "_";


LogFileSeparator();
*LogFile << InFileName << endl << endl;

*LogFile << "Job Prefix = " << JobPrefix << endl;
InputFilesDir = ReadString("InputFilesDir", &InFile);
SimType = ReadInt("SimType"," ",0,0,NO_BOUNDS,&InFile);
qtStatSamples = ReadInt("qtStatSamples"," ",0,-1,LOWER_ONLY,&InFile);
qtMapSpans = ReadInt("qtMapSpans"," ",0,-1,LOWER_ONLY,&InFile);

NumChannsDemux = ReadInt("NumChannsDemux"," ",0,-1,LOWER_ONLY,&InFile);

DemuxChannsArray = new int[NumChannsDemux];

if(!DemuxChannsArray)
  {
    *LogFile << "Malloc error in Startup" << endl;
    exit(1);
  }


char C_String[40]; 
string DemuxChannName;


for(int demuxCh=0;demuxCh<NumChannsDemux;demuxCh++)
  {
    
     sprintf(C_String,"DemuxChann%d",demuxCh+1);
     DemuxChannName = C_String;

     DemuxChannsArray[demuxCh] = ReadInt(DemuxChannName," ",0,-1,
                                         LOWER_ONLY,&InFile) - 1;

  }

LogFileSeparator();

*LogFile << "Channel array indices to be demuxed: " << endl << endl;

for(int demuxCh=0;demuxCh<NumChannsDemux;demuxCh++)
  *LogFile << DemuxChannsArray[demuxCh] +1 << endl;


InFile.close();

// ## There should be a directory called ProcessControl in 
// #  the home directory of the user.
string ProcessControlFileName = "ProcessControl/Proc010209.txt";
oProcessControl.InitProcessControl( ProcessControlMode
                                   ,ProcessControlFileName
                                   ,argv[0]);

} // end constructor

// #####################################################################
