// $Id: StartupHua.cc,v 1.1 2006/05/11 23:56:24 zweck Exp $

//###################################################################
//
//      Optical Communication Systems Simulator Example
//
//      For other examples check the personal applications
//      of the current users, such as ocsApp[LastName].cc
//
//      Copyright (2000):
//      Optical Fiber Communications Laboratory (OFCL)
//      Computer Science & Electrical Engineering Department (CSEE)
//      University of Maryland Baltimore County (UMBC)
//
//###################################################################


//# include "StartupExampleHuaPMF.hh"

# include "StartupHua.hh"

extern ofstream *LogFile;

StartupExample::StartupExample(string InFileName, int argc, char *argv[])
{

ifstream InFile(InFileName.c_str(),ios::in);    
   
if (!InFile) 
 {
    cerr << "Error: Input file "<< InFileName 
         << " could not be opened."<< endl;
    exit(1);
 }

JobDir = ReadString("JobDir",&InFile);
JobName =  ReadString("JobName",&InFile);



LogFileName = JobDir + JobName + ".log";

 cout << endl
      << "Log File = " << LogFileName << endl << endl;

LogFile= new ofstream(LogFileName.c_str(),ios::out);
   
if (!LogFile) 
  {
    cerr << "Error: ocs.log could not be open." << endl << flush;
    exit(1);
  }    

JobPrefix = JobDir + JobName + "_";


LogFileSeparator();
*LogFile << InFileName << endl << endl;

*LogFile << "Job Prefix = " << JobPrefix << endl;



SimType = ReadInt("SimulationType"," ",0,0,NO_BOUNDS,&InFile);
NumMonteCarloExpts = ReadInt("NumMonteCarloExpts"," ",0,0,NO_BOUNDS,
                              OPTIONAL_NO_WARNING,0,&InFile);

LogFileSeparator();


InFile.close();
								   
} // end constructor

// #####################################################################
