// $Id: statistic.hh,v 1.1 2007/10/24 14:39:21 zweck Exp $

#ifndef __STATISTIC_HH__
#define __STATISTIC_HH__

#include "wichmann_hill.hh"


//#include "ron_base.hh"

//#include "/home/home1/walter/ocs_cvs/optics/C++/ocs/include/ocs.hh"

inline double lin_map(double x, double a1, double diff_a, double b1, double diff_b);
inline int lin_map(double x, double a1, double diff_a, int b1, int num_b);
inline double lin_map(int x, int a1, int num_a, double b1, double diff_b);
inline double lin_map(int x, int a1, int num_a, int b1, int num_b);
inline double lin_interpolate(double x, double a1, double diff_a, int b1, int num_b, double *data);
inline cplx lin_interpolate(double x, double a1, double diff_a, int b1, int num_b, cplx *data);

/*
enum{MOSIX_UNLOCK, MOSIX_LOCK};
int lock_or_unlock_mosix(int what);
int cpujob_mosix(void);
int slow_mosix(void);
*/
inline double dB_to_factor(double G_dB);
inline double factor_to_dB(double factor);

double gaussian(double t, double t0, double FWHM_norm);
void gaussian_pdf(int N, double stan_dev, double *vec,
  Wichmann_Hill *my_rand);

void gaussian_pdf(int N, double stan_dev, double *vec,
  Wichmann_Hill *myrand, unsigned* calls_counter);

void    my_error(char *spruch);

double peak_power(cplx *in, int N, int *max_loc=0);
//double pulse_energy(cplx *in, int N, double width);
double pulse_energy_rect(cplx *in, int N, double width);

double mean(double *in, size_t len);
double var(double *in, size_t length, double mean_in=NAN);
//added by Walter
double mean(unsigned int *in, size_t len);
double var(unsigned int *in, size_t length, double mean_in=NAN);
//end
double var_estimated_mean(double Q, double xm, double x_mean, size_t N);
double center_of_gravity(double *weight, size_t N, double sum_weight_in=NAN);
double var_of_gravity(double *weight, size_t N, double center_in, double sum_weight=NAN);
#endif  /*  __STATISTIC_HH__ */
/**/

