// $Id: 

//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _OCS_BEAM_SPLITTER_HH_
#define _OCS_BEAM_SPLITTER_HH_

#include "ocsOptSignal.hh"

// ##### Class BeamSplitter
class BeamSplitter
{
   public:
      BeamSplitter( OptSignal *oOptSignalATmp
                   ,OptSignal *oOptSignalBTmp);
      void SetPowerSplittingFactor(double PowerSplittingFactorTmp);
      void SplitOptSignal();
      void SplitOptSignalScalar();
   private:          
      OptSignal *oOptSignalA;
      OptSignal *oOptSignalB;
      int qtPoints;
      double PowerSplittingFactor;
};

#endif //## _OCS_BEAM_SPLITTER_HH_
