// $Id: 
//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _OCS_POL_DEP_ATTENUATOR_HH_
#define _OCS_POL_DEP_ATTENUATOR_HH_

#include "ocsOptSignal.hh"
#include "ocsReduPolDepAttenuator.hh"

// ##### Input parameter to initialize Pol. Dep. Loss Sources
//struct PolDepAttenuatorParam 
//{
//   //int    PolDepLossType;
//   double PolDepAttenuation;	
//   double StokesMaxAttenuation[4];
//};

// #### Class PolDepAttenuator

//!

/*!

Current does not keep track of OptSignal->TotalNoiseSpectralDensityGaussianStatistics

*/

class PolDepAttenuator
{
   public:
      PolDepAttenuator() {ObjectInitialized = 0;};
      PolDepAttenuator(string InFileName, 
                       OptSignal *oOptSignalTmp);        
      PolDepAttenuator(OptSignal *oOptSignalTmp); 
      PolDepAttenuator(OptSignal *oOptSignalTmp
                          ,double PolDepAttenuationX_Tmp
                          ,double PolDepAttenuationY_Tmp); 
      void InitPolDepAttenuator(OptSignal *oOptSignalTmp);
      void SetPolDepAttenuation(double PolDepAttenuationX_Tmp
                              ,double PolDepAttenuationY_Tmp);
      void SetPolDepAttenuationX(double PolDepAttenuationX_Tmp);
      void SetPolDepAttenuationY(double PolDepAttenuationY_Tmp);
      void SwitchOptSignalData(OptSignal *oOptSignal2);      
      //void GetTransmMatrixCoefficients(void);
      //void SyncNumChannels(void);
      void PolDepAttenuate(void);

  // added by Hai 7-1-03
  	void UpdateJonesMatrixPDL(void);    


   private:
      int ObjectInitialized;
      OptSignal *oOptSignal;
      //double NumChannels;       
      double LinearPolDepAttenuationX;  
      double LinearPolDepAttenuationY;  
      int qtPoints;
      //double StokesSignalTmp[4];
      //double StokesNoiseTmp[4];
      double Tm00,Tm01,Tm22;

   // added by Hai 7-1-03
     cplx *JonesMatrix;   //added by Hai 7-1-03
     int NumberOfChannels;  //added by Hai 7-1-03   

     ReduPolDepAttenuator * oReduPolDepAttenuator;

};

#endif //_OCS_POL_DEP_ATTENUATOR_HH_
