// $Id: ocsPolarizBeamSplitter.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $

//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _OCS_POLARIZ_BEAM_SPLITTER_HH_
#define _OCS_POLARIZ_BEAM_SPLITTER_HH_

#include "ocsOptSignal.hh"

// ##### Class PolarizBeamSplitter
class PolarizBeamSplitter
{
   public:
      PolarizBeamSplitter( OptSignal *oOptSignalATmp
                          ,OptSignal *oOptSignalBTmp);
      //void SetSplittingPolarization( double S1PolarizerTmp
      //                  ,double S2PolarizerTmp
      //                  ,double S3PolarizerTmp);
      void SetPolarizBeamSplitterAngle(double theta2);
      void SetPolarizBeamRetarderAngle(double phi2);
      void SetPolarizBeamSplitterHorizontal_Vertical(void);
      void SetPolarizBeamSplitterCircular(void);
      void SetPolarizBeamSplitterDiagonal(void);
      void PolarizSplitOptSignal();
      //void PolarizSplitOptSignal_OLD();
      //void PolarizSplitOptSignalFreq();
   private:          
      OptSignal *oOptSignalA;
      OptSignal *oOptSignalB;
      int qtPoints;
      double theta;
      double phi;
      //double S1Polarizer;
      //double S2Polarizer;
      //double S3Polarizer;
};

#endif //## _OCS_POLARIZ_BEAM_SPLITTER_HH_
