// $Id:
//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _OCS_POLARIZ_TRANSFORMER_HH_
#define _OCS_POLARIZ_TRANSFORMER_HH_

#ifndef _OCS_TYPE_SCATTERING_
#define _OCS_TYPE_SCATTERING_
enum typeScattering { RX_RY_RX = 1, 
                      RY_RZ_RY = 2, 
                      RX_RZ_RY = 3};
#endif

#include "ocsOptSignal.hh"
#include "ocsReduPolarizTransformer.hh"

// ##### Class PolarizTransformer
class PolarizTransformer
{
   public:
      PolarizTransformer( int TypeScattering2, 
                          OptSignal *oOptSignalTmp);
      
      
      void TransformPolarization( double psi
                                 ,double theta
                                 ,double phi);
     
      void TransformPolarization(void);				 
      void UndoLastPolarizTransformation(void);      

      void TransformPolarization(cplx Jones0,cplx Jones1);
      
      string WriteTypeScattering(void);				 
      void SwitchOptSignalData(OptSignal *oOptSignal2);      
  
   private:
      typeScattering TypeScattering;   
      OptSignal *oOptSignal;            
      cplx TransM[2][2];
      double psiLast, thetaLast, phiLast;      
      int qtPoints;
  
      ReduPolarizTransformer * oReduPolarizTransformer;

};

#endif /* _OCS_POLARIZ_TRANSFORMER_HH_ */
