// $Id:
//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2000):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _OCS_OPT_POLARIZER_HH_
#define _OCS_OPT_POLARIZER_HH_

#include "ocsOptSignal.hh"
#include "ocsReduPolarizer.hh"

//! Adapted by John Zweck (Jan 2006) from code written by Ivan Lima
//! See doumentation for Polarizer::PolarizeOptSignal() for details.

class Polarizer
{
   public:
      Polarizer( OptSignal *oOptSignalTmp);
      void SetPolarization(double S1PolarizerTmp,
		       double S2PolarizerTmp,
                       double S3PolarizerTmp);
      void PolarizeOptSignal();

   private:
      OptSignal *oOptSignal;      
      double * SPolarizer;
      ReduPolarizer * oReduPolarizer;
};

#endif /* _OCS_OPT_POLARIZER_HH_ */
