// $Id: ocsReduLumpedLoss.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $

//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2001):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _OCS_REDU_LUMPED_LOSS_HH_
#define _OCS_REDU_LUMPED_LOSS_HH_


#include "ocsReduOptSignal.hh"

// ##############################################
// #### Classes of objects for the reduced model
// ##############################################

// #### Class ReduLumpedLoss


class ReduLumpedLoss
{
   public:
      ReduLumpedLoss(double LossdB2, ReduOptSignal *oReduOptSignal2);
      ReduLumpedLoss(string InFileName, ReduOptSignal *oReduOptSignal2);   
      void InitReduLumpedLoss(double LossdB2, ReduOptSignal *oReduOptSignal2);   

      void ApplyLumpedLoss();
      void SetLossdB(double LossdB2);
      double GetLossdB(void) {return LossdB;};

   private:   
      double LossdB;
      double LossLinear;
      ReduOptSignal * oReduOptSignal;
};



#endif /* _OCS_LUMPED_LOSS_HH_ */
