// $Id:
//###################################################################
//
//           Optical Communication Systems Simulator
//
//       Copyright (2006):
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
//###################################################################

#ifndef _OCS_REDU_OPT_POLARIZER_HH_
#define _OCS_REDU_OPT_POLARIZER_HH_

#include "ocsReduOptSignal.hh"

//! Adapted by John Zweck (Jan 2006) from code written by Ivan Lima
//! See doumentation for ReduPolarizer::PolarizeOptSignal() for details.

class ReduPolarizer
{
   public:
      ReduPolarizer(ReduOptSignal *oReduOptSignalTmp);

      void SetPolarization(double S1PolarizerTmp,
			   double S2PolarizerTmp,
			   double S3PolarizerTmp);

      void PolarizeOptSignal();

   private:
      ReduOptSignal *oReduOptSignal;      
      double * SPolarizer;
};

#endif /* _OCS_REDU_OPT_POLARIZER_HH_ */
